# Originall copied and modified from the built-in Kaniko template

kaniko-build:
  image:
    # For latest releases see https://github.com/GoogleContainerTools/kaniko/releases
    # Only debug/*-debug versions of the Kaniko image are known to work within Gitlab CI
    name: gcr.io/kaniko-project/executor:debug
    entrypoint: [""]
  variables:
    # The Dockerfile to build
    DOCKERFILE: Dockerfile.web
    IMAGE_NAME: "hello-world"
    VERSION: $CI_COMMIT_SHORT_SHA
    KANIKO_ARGS: ""
  script:
    - mkdir -p /kaniko/.docker
    # Write credentials to access Gitlab Container Registry within the runner/ci
    - echo "{\"auths\":{\"$CI_REGISTRY\":{\"auth\":\"$(echo -n ${CI_REGISTRY_USER}:${CI_REGISTRY_PASSWORD} | base64 | tr -d '\n')\"}}}" > /kaniko/.docker/config.json
    # Build and push the container. To disable push add --no-push
    - /kaniko/executor --context $CI_PROJECT_DIR --dockerfile $CI_PROJECT_DIR/Dockerfile --destination $CI_REGISTRY_IMAGE/${IMAGE_NAME}:$VERSION $KANIKO_ARGS
    - |
      cat << EOF  > deploy.env
      IMAGE_REF=$CI_REGISTRY_IMAGE/${IMAGE_NAME}:$VERSION
      EOF
  after_script:
    - cat deploy.env
  artifacts:
    reports:
      dotenv: deploy.env

deploy:staging:
  image: curlimages/curl:latest
  stage: deploy
  needs:
    - job: kaniko-build
      artifacts: true
  variables:
    MANIFEST_PROJECT_ID: 36616851
    TARGET_ENVIRONMENT: staging
  script:
  - printenv
  - 'curl --fail --request POST --form token=${CI_JOB_TOKEN} --form ref=main --form "variables[IMAGE_REF]=${IMAGE_REF}" --form "variables[TARGET_ENVIRONMENT]=${TARGET_ENVIRONMENT}" "${CI_API_V4_URL}/projects/${MANIFEST_PROJECT_ID}/trigger/pipeline"'
  environment:
    name: $TARGET_ENVIRONMENT

deploy:production:
  image: curlimages/curl:latest
  stage: deploy
  needs:
    - job: kaniko-build
      artifacts: true
  variables:
    MANIFEST_PROJECT_ID: 36616851
    TARGET_ENVIRONMENT: production
  script:
  - 'curl --fail --request POST --form token=${CI_JOB_TOKEN} --form ref=main --form "variables[IMAGE_REF]=${IMAGE_REF}" --form "variables[TARGET_ENVIRONMENT]=${TARGET_ENVIRONMENT}" "${CI_API_V4_URL}/projects/${MANIFEST_PROJECT_ID}/trigger/pipeline"'
  environment:
    name: $TARGET_ENVIRONMENT
  rules:
    - if: '$CI_COMMIT_TAG'
      when: manual
  
